cdeck biock1
      subroutine biock1 (rtemp,ltemp)
      character*8 temp(1000)
c
c   biock1 processes the argument list, gets variable labels, and
c      gets value labels for age and sex variables.
c
      include 'maincomon.for'
      include 'biocheckc.for'
c   l o c a l   v a r i a b l e s
c
      character*8 blank,comma,equal
      integer nkeys
      parameter (nkeys=16)
      character*8 keywrd(nkeys)
      integer iw,nw,m,i
      character*60 n
      logical   qerr
      logical qnumbr
      double precision atof
      data equal/'='/,comma/','/,blank/' '/
      data keywrd/'xcoor   ','ycoor   ','time    ','age     ',
     1            'sex     ','id      ','xmin    ','ymin    ',
     2            'xmax    ','ymax    ','speedlim','maxdist ',
     3            'distance','activity','maxanim ','maxcases'/
c
c   check that the number of subfiles is not greater than
c   the dimensions in common block biockc
c
      if (nsmax.gt.200) go to 470
c
c   set default parameter values
c
      do 10 i=1,6
 10   varnum(i)=0
      do 20 i=1,nsmax
      xmin(i)=-r1mach(2)
      ymin(i)=-r1mach(2)
      xmax(i)=r1mach(2)
      ymax(i)=r1mach(2)
      amph(i)=0.
      distm(i)=0.
   20 iact(i)=0
      maxaim=nsmax
      maxcase=500
c
c   pick up argument list
c
c     nw1=ltemp-5
      nw1=1000
      write(0,*)'Input parameters for BIOCHECK are:'
      write(0,*)
     1 'xcoor=x_field ycoor=y_field time=time_field [age=age_field]'
      write(0,*)
     1 '[sex=sex_field] [id=id_field]'
      write(0,*)
     1 '[xmin=minimum x(s)] [xmax=maximum x(s)] [ymin=minimum y(s)]'
      write(0,*)
     1 '[ymax=maximum y(s)] [speedlim=speed limit(s) [mph|kmph|mps|m]]'
      write(0,*)
     1 '[distance=maximum distance(s) [miles|km|m|feet]]'
      call stack (temp,nw1,nw)
      iw=0
c
c   process options + statistics card
c
      call statop
c
c   list argument list on iolp for debugging
c
c     write (iolp,401) (i,temp(i),i=1,nw)
c 401 format (5(1x,i3,2h,',a8,1h'))
c
c   interpret procedure call card
c
c   first make sure a comma terminates the list
c
      if (temp(nw).eq.comma) go to 40
      nw=nw+1
      temp(nw)=comma
      go to 40
   30 if (temp(iw).ne.comma) iw=iw-1
   40 iw=iw+3
      if (iw.gt.nw) go to 370
      do 50 i=1,nkeys
      if (temp(iw-2).eq.keywrd(i)) go to (60,60,60,60,60,60,70,110,150,1
     1 90,230,270,270,310,350,360), i
   50 continue
      write (iolp,510) temp(iw-2),temp(iw-1),temp(iw)
      iw=iw+1
      go to 40
   60 varnum(i)=atof(temp(iw))
c   set up formats to read data in observ
      if (i.le.3) then
         vfmt(varnum(i))=0
      else
         vfmt(varnum(i))=10
      endif
      varnam(varnum(i))=keywrd(i)
      iw=iw+1
      go to 30
   70 do 80 i=1,nsmax
      xmin(i)=atof(temp(iw))
      iw=iw+1
      if (.not. qnumbr(temp(iw))) go to 90
   80 continue
      go to 30
   90 do 100 j=i,nsmax
  100 xmin(j)=xmin(i)
      go to 30
  110 do 120 i=1,nsmax
      ymin(i)=atof(temp(iw))
      iw=iw+1
      if (.not. qnumbr(temp(iw))) go to 130
  120 continue
      go to 30
  130 do 140 j=i,nsmax
  140 ymin(j)=ymin(i)
      go to 30
  150 do 160 i=1,nsmax
      xmax(i)=atof(temp(iw))
      iw=iw+1
      if (.not. qnumbr(temp(iw))) go to 170
  160 continue
      go to 30
  170 do 180 j=i,nsmax
  180 xmax(j)=xmax(i)
      go to 30
  190 do 200 i=1,nsmax
      ymax(i)=atof(temp(iw))
      iw=iw+1
      if (.not. qnumbr(temp(iw))) go to 210
  200 continue
      go to 30
  210 do 220 j=i,nsmax
  220 ymax(j)=ymax(i)
      go to 30
  230 do 240 i=1,nsmax
      amph(i)=atof(temp(iw))
      iw=iw+1
      if (qnumbr(temp(iw))) go to 240
      if (temp(iw).eq.comma) then
         go to 250
      else if (temp(iw).eq.'mph     ') then
         amph(i)=amph(i)*1.609344
         iw=iw+1
      else if (temp(iw).eq.'kmph    ') then
         iw=iw+1
      else if (temp(iw).eq.'mps     ') then
         amph(i)=amph(i)*60.*60.
         iw=iw+1
      else if (temp(iw).eq.'mpm     ') then
         amph(i)=amph(i)*60.
         iw=iw+1
      endif
      if (temp(iw).eq.comma .or. .not.qnumbr(temp(iw))) go to 250
  240 continue
      go to 30
  250 do 260 j=i,nsmax
  260    amph(j)=amph(i)
      go to 30
  270 do 280 i=1,nsmax
      distm(i)=atof(temp(iw))
      iw=iw+1
      if (qnumbr(temp(iw))) go to 280
      if (temp(iw).eq.comma) then
         go to 290
      else if (temp(iw).eq.'m       ') then
         distm(i)=distm(i)/1000.
         iw=iw+1
      else if (temp(iw).eq.'mile    ' .or. temp(iw).eq.'miles   ') then
         distm(i)=distm(i)*1.609344
         iw=iw+1
      else if (temp(iw).eq.'km      ') then
         iw=iw+1
      else if (temp(iw).eq.'feet    ') then
         distm(i)=distm(i)*304.8
         iw=iw+1
      endif
      if (temp(iw).eq.comma .or. .not.qnumbr(temp(iw))) go to 290
  280 continue
      go to 30
  290 do 300 j=i,nsmax
  300 distm(j)=distm(i)
      go to 30
  310 do 320 i=1,nsmax
      iact(i)=int(atof(temp(iw)))
      iw=iw+1
      if (temp(iw).eq.comma) go to 330
  320 continue
      go to 30
  330 do 340 j=i,nsmax
  340 iact(j)=iact(i)
      go to 30
  350 maxaim=int(atof(temp(iw)))
      iw=iw+1
      go to 30
  360 maxcase=int(atof(temp(iw)))
      iw=iw+1
      go to 30
c
c   take care of some clean-up
c
c   get variable labels
c
  370 do 390 i=1,6
      do 380 j=1,5
  380 varlab(j,i)=blank
c     if (varnum(i).eq.0) go to 390
c     if (lblpnt(3,varnum(i)).eq.0) go to 390
c     call point2 (lblpnt(3,varnum(i)))
c     call read2 (varlab(1,i))
  390 continue
c
c   get value labels for age and sex
c
c     if (varnum(4).ne.0) call biock4 (agelab,nagelab,10,varnum(4))
c     if (varnum(5).ne.0) call biock4 (sexlab,nsexlab,3,varnum(5))
c
c   error checking section
c
      do 400 i=1,3
      if (varnum(i).eq.0) go to 460
  400 continue
      do 410 i=1,nsmax
      if (xmin(i).ge.xmax(i)) go to 480
      if (ymin(i).ge.ymax(i)) go to 490
  410 continue
      return
c
c   error return section
c
c   comma expected but not found
c
  420 n='comma expected but not found'
      go to 500
c
c   unrecognized parameter specified
c
  430 n='unrecognized parameter specified'
      go to 500
c
c   unrecognized variable specified
c
  440 n='unrecognized field specified'
      go to 500
c
c   more than one variable specified in parameter specification
c
  450 n='more than one field specified in parameter specification'
      go to 500
c
c   xcoor, ycoor, or time specification missing
c
  460 n='xcoor, ycoor, or time specification missing'
      go to 500
c
c   number of subfiles exceeds dimensions
c
  470 n='number of subfiles exceeds dimensions'
      go to 500
c
c   xmin greater than xmax for at least one subfile
c
  480 n='xmin greater than xmax for at least one subfile'
      go to 500
c
c   ymin greater than ymax for at least one subfile
c
  490 n='ymin greater than ymax for at least one subfile'
      go to 500
  500 call error (n)
      return
c
  510       format (1h0,'incorrect keyword',3(1x,a8))
      end
