      program fields
      integer field(2,80),numfld,nargs,subfil(20),numsub,errfld(20),
     1   numefd,itemp(20)
      real evalue(20),rtemp(20)
      character string(2)*150
      character xeqlin(80)*20
      character fldstr(2,20)*40
      equivalence (fldstr,xeqlin)
      character fmt*10, temp*40, filein*40, filout*40
      integer iblank, idash, icomma, i, j, isub
      logical first, subchg
      data filein/' '/,filout/' '/
c
c   get execution line
c
      write(0,*) 'The arguments for FIELDS are:'
      write(0,*) 'i=input_file   o=output_file (created by FIELDS)'
      write(0,*) 'fields specified as start_column-end_column'
      write(0,*)'  (as many as needed to specify the input fields)'
      write(0,*)'subfile(s)=field_#,field_#,...'
      write(0,*)'  (The numbers denote fields to monitor -- whenever'
     1           //' one of these fields'
      write(0,*)'   change, a subfile marker is placed in the output'
     1           //'file.)'
      write(0,*)'error(s)=field_#,field_#,...   '
     1        //'evalue=value_1, value_2,...'
      write(0,*)'  (The field_#''s denote fields to monitor -- whenever'
      write(0,*)'   the value of the field exceeds the corresponding'
      write(0,*)'   evalue, the location is deleted.  This option is'
      write(0,*)'   is intended to delete locations with large error'
      write(0,*)'   polygons or confidence ellipses.)'
      write(0,*)'As an example, the input line'
      write(0,*)'  i=deer.dat subfiles=2,3 1-10 15-15 16-16 21-27',
     1 ' 28-34 o=deer.fld'
      write(0,*)'tells FIELDS to read the data from the file deer.dat,'
      write(0,*)'put subfile markers in when the values in fields 2'
      write(0,*)'and 3 change, and use columns 1-10 for field 1, 15'
      write(0,*)'for field 2, 16 for field 3, 21-27 for field 4, and'
      write(0,*)'28-34 for field 5.'
      write(0,*)'Note that blanks are used to delimit the arguments'
      write(0,*)'given in the execution line.'
      call args (nargs, xeqlin)
      numfld=0
      do 10 i=1,nargs
         if (xeqlin(i)(1:2).eq.'i=' .or. xeqlin(i)(1:2).eq.'I=') then
            iblank=index(xeqlin(i),' ')
            filein=xeqlin(i)(3:iblank-1)
         else if (xeqlin(i)(1:2).eq.'o='
     1       .or. xeqlin(i)(1:2).eq.'O=') then
            iblank=index(xeqlin(i),' ')
            filout=xeqlin(i)(3:iblank-1)
         else if (xeqlin(i)(1:7).eq.'subfile'
     1         .or. xeqlin(i)(1:7).eq.'SUBFILE') then
            call argval(xeqlin(i),subfil,rtemp,numsub,'i','subfile')
         else if (xeqlin(i)(1:5).eq.'error'
     1         .or. xeqlin(i)(1:5).eq.'ERROR') then
            call argval(xeqlin(i),errfld,rtemp,numefd,'i','error')
         else if (xeqlin(i)(1:6).eq.'evalue'
     1         .or. xeqlin(i)(1:6).eq.'EVALUE') then
            call argval(xeqlin(i),itemp,evalue,numevl,'f','evalue')
         else
            iblank=index(xeqlin(i),' ')
            idash=index(xeqlin(i),'-')
            if (idash.ge.2 .and. iblank.gt.idash) then
               numfld=numfld+1
               if (numfld.gt.80) then
                  write(0,*) 'ERROR -- Only 80 fields are allowed.'
                  numfld=80
               endif
               temp=xeqlin(i)(1:idash-1)
               write(fmt,'(2h(i,i2.2,1h))') idash-1
               read(temp,fmt) field(1,numfld)
               temp=xeqlin(i)(idash+1:iblank-1)
               write(fmt,'(2h(i,i2.2,1h))') iblank-idash-1
               read(temp,fmt) field(2,numfld)
            else
               write(0,*) 'Invalid field argument -- '//xeqlin(i)
            endif
         endif
 10      continue
      if (filein.eq.' ') then
         write(0,*) 'ERROR -- no input file specified.'
         go to 60
      endif
      open(unit=4,file=filein,status='old')
      if (filout.eq.' ') then
         write(0,*)
     1       'No output file specified -- data to standard output. '
      else
         open(unit=6,file=filout,status='unknown')
      endif
      if (numefd .ne. numevl) then
         write(0,*) 'Number of errfld .ne. number of evalue'
         numefd=min(numefd,numevl)
         numevl=min(numefd,numevl)
      endif
c
c   sort the list of subfile fields
c
      if (numsub.gt.1) then
         do 80 i=1,numsub-1
            do 80 j=2,numsub
               if (subfil(i).gt.subfil(j)) then
                  isub=subfil(i)
                  subfil(i)=subfil(j)
                  subfil(j)=isub
               endif
 80            continue
      endif
      first=.true.
 40   read(4,'(a)',end=60) string(1)
      isub=1
      ipos=0
      do 50 i=1,numfld
         ipos=ipos+1
         iwidth=field(2,i)-field(1,i)
         do 85 ierr=1,numefd
             if (errfld(ierr).ne.i) go to 85
             temp=string(1)(field(1,i):field(2,i))
             write(fmt,'(2h(f,i2.2,3h.0))') iwidth+1
             read(temp,fmt) fldval
             if (fldval.gt.evalue(ierr)) go to 40
 85          continue
         string(2)(ipos:ipos+iwidth)=string(1)(field(1,i):field(2,i))
         if (subfil(isub).eq.i) then
            fldstr(2,isub)=string(1)(field(1,i):field(2,i))
            if (isub.lt.numsub) isub=isub+1
         endif
         ipos=ipos+iwidth+1
         string(2)(ipos:ipos)=':'
 50      continue
c
c   if this is the first case to be processed, set the
c   subfile fields equal
c
      if (first) then
         do 55 isub=1,numsub
 55      fldstr(1,isub)=fldstr(2,isub)
         first=.false.
      endif
c
c   check for change in subfile variables
c
      subchg=.false.
      do 70 isub=1,numsub
         if (fldstr(1,isub).ne.fldstr(2,isub)) then
            subchg=.true.
         endif
         fldstr(1,isub)=fldstr(2,isub)
 70      continue
      if (subchg) then
         write(6,*) '##########'
      endif
c
c   check for field > evalue
c
c   write out the new case string
      write(6,*) string(2)(1:ipos)
      go to 40
 60   stop
      end
c   args is for use on PC
c   DO NOT associate unit 5 with a file until after args is called
      subroutine args(nargs,xeqlin)
      character*(*) xeqlin(*)
      character*150 string,temp
      integer nargs, iblank
      nargs=0
      write(0,'(1x,a)')
     1    'Enter execution line arguments (last line is ^Z): '
 5    read(*,'(a)',end=30) string
 10   if (string.eq.' ') go to 5
      call lblksp(string)
      iblank=index(string,' ')
      nargs=nargs+1
      xeqlin(nargs)=string(1:iblank-1)
      temp=string(iblank:150)
      string=temp
      go to 10
 30   return
      end
      subroutine lblksp(string)
      character*(*) string
      if (string(1:1).ne.' ') return
      do 10 i=2,len(string)
          if (string(i:i).ne.' ') go to 20
 10       continue
      return
 20   nonblk=i
      do 30 i=nonblk,len(string)
         ib=i-nonblk+1
         string(ib:ib)=string(i:i)
         string(i:i)=' '
 30      continue
      return
      end
      subroutine argval(xeqlin,args,fargs,numarg,formt,avalue)
      character*20 xeqlin
      integer args(20),numarg
      real fargs(20)
      character*1 formt
      character*8 avalue
      integer iequal, iblank, idash, icomma
      character*20 temp,fmt
      numarg=0
            iequal=index(xeqlin,'=')
            if (iequal.eq.0) then
               write(0,*) 'ERROR -- No equals in argument'//avalue
               go to 10
            endif
            temp=xeqlin(iequal+1:)
 15         xeqlin=temp
            iblank=index(xeqlin,' ')
            icomma=index(xeqlin,',')
            if (icomma.eq.0) icomma=iblank
            numarg=numarg+1
            if (numarg.gt.20) then
               write(0,*)
     1            'ERROR -- only 20 '//avalue//' fields are allowed.'
               numarg=20
            endif
            temp=xeqlin(1:icomma-1)
            if (formt.eq.'i') then
               write(fmt,'(2h(i,i2.2,1h))') icomma-1
               read(temp,fmt) args(numarg)
            else
               write(fmt,'(2h(f,i2.2,3h.0))') icomma-1
               read(temp,fmt) fargs(numarg)
            endif
            temp=xeqlin(icomma+1:)
            if (temp.ne.' ') go to 15
      return
 10   do 11 i=1,20
         fargs(i)=0.0
 11      args(i)=0
      numarg=0
      return
      end
