:begin
rem
rem    Wander into the BASIC program that checks for bad locations
rem       and formats the data in a form appropriate for HOMER
rem
if "%1" == "" goto quit
echo %1 > infil
basica ferbust
rem
rem    Clean filespace in anticipation of building these files
rem               as a result of HOMER execution
rem
del homer.dat
del homer.loc
del homer.con
del homer.out
del homer.elp
ren tf%1 homer.dat
rem
rem      Execute HOMER to compute home range estimates and generate
rem        HOMER.LOC -- containing locations
rem        HOMER.ELP -- containing 200 perimeter points for JT ellipse
rem        HOMER.ELU -- containing 200 perimeter points for JT ellipse
rem                     constructed from just the unique data
rem        HOMER.DUN -- containing 200 perimeter points for Dunn ellipse
rem        HOMER.CON -- containing the vertices of convex polygon
rem
homer < homer.in > homer.out
rem
rem      Send hardcopy of HOMER run to the printer
rem
echo tf%1 > prn
copy homer.out prn
setprint page
rem
rem      Rename all files generated by HOMER to *.PRN extensions so
rem                 they can be accessed by Lotus
rem
ren homer.loc %1l.prn
ren homer.elp %1e.prn
ren homer.con %1c.prn
cd\123files
rem
rem     Send string of Lotus commands to Lotus via KEY-FAKE to build
rem            three graphs of Locations, Ellipse and Polygon and
rem                           exit Lotus
rem
kf 0 13"/frtpl"13 @30"%1l"13 @48"%1e"13 @48"%1c"13 @46 @18"%1l"13 @33 13"%1e"13 @34 13"%1c"13 27 27 27 @35
123
cd\fl
rem
rem      Now in FreeLance, suck in three graphs just made by Lotus,
rem             overlay them and be prepared to add study area
rem              overlay as well as any notation to be made.
rem
kf 13 13 "ofpc:\ferrets"13"fiptf%1l"13 @81"fiptf%1e"13"sam"@81 13 @81"vcfiptf%1c"13"sam"@81 13"snfstf%1al"13
fl
shift
cd\ferrets
goto begin
:quit

