*----------------------------------------------------------*
| SAS code to build SAS data set for the Piceance deer     |
|   data to provide a major example.                       |
*----------------------------------------------------------*;
libname library 'c:';
data library.deer;
   infile 'deer.dat'; /* deer.dat is modified output from TRIANG */
   informat date yymmdd6. time time5.;
   length habitat $ 10;
   input date time id $ x y ellipsci habitat $ year $ 1-2;
   format date date. time time5.;
   label date='Date of location'
         time='Time of location'
         id='Animal id (year and last 3 digits of frequency)'
         x='x UTM coordinate'   
         y='y UTM coordinate'
         ellipsci='95% confidence interval on location'
         habitat='Habitat type from MOSS map'; 
   id=year||'-'||id;
proc sort; by id date time;
run;
