* Black duck data from Pollock et al. (1988), In Press.;
data black;
   title 'Black duck data from Pollock et al. (1988), In Press';
   input time norisk nodead nocensor noadded age;
   cards;
 2 50 1 0 0 1
 6 49 0 1 0 0
 6 48 0 1 0 1
 7 47 1 0 0 0
13 46 1 0 0 1
14 45 0 1 0 0
16 44 1 0 0 1
16 43 0 1 0 1
17 42 1 0 0 1
17 41 0 1 0 1
20 40 0 1 0 1
21 39 1 0 0 1
22 38 1 0 0 0
26 37 1 0 0 0
26 36 1 0 0 0
27 35 1 0 0 0
28 34 0 1 0 1
29 33 1 0 0 0
32 32 1 0 0 0
32 31 0 1 0 1
34 30 1 0 0 0
34 29 1 0 0 0
37 28 1 0 0 0
40 27 1 0 0 0
41 26 1 0 0 1
44 25 1 0 0 0
49 24 0 1 0 0
54 23 0 1 0 1
56 22 0 1 0 0
56 21 0 1 0 0
57 20 0 1 0 1
57 19 0 1 0 0
58 18 0 1 0 0
63 17 0 1 0 1
63 16 0 0 0 0
63 15 0 0 0 0
63 14 0 0 0 0
63 13 0 0 0 0
63 12 0 0 0 0
63 11 0 0 0 1
63 10 0 0 0 0
63  9 0 0 0 0
63  8 0 0 0 0
63  7 0 0 0 1
63  6 0 0 0 1
63  5 0 0 0 1
63  4 0 0 0 0
63  3 0 0 0 0
63  2 0 0 0 0
63  1 0 0 0 0
;
data kaplan;
   retain Shat 1 Greensum 0;
   set black;
   Shat=Shat*(1 - nodead/norisk);
   Greensum = Greensum + nodead/(norisk*(norisk-nodead));
   GvarShat = Shat*Shat*Greensum;
   GseShat = sqrt(GvarShat);
   varShat = Shat**2*(1 - Shat)/norisk;
   seShat = sqrt(varShat);
   lci = Shat - 1.96*GseShat;
   uci = Shat + 1.96*GseShat;
   output;
proc print;
proc plot;
   plot Shat*time='*' lci*time='-' uci*time='-' / overlay;
data spring85;
   title 'Spring, 1985 bob-white quail data from Pollock';
   input time norisk nodead nocensor noadded;
   cards;
 1 18 0 0 0
 2 18 0 0 0
 3 18 2 0 0
 4 16 0 0 0
 5 16 0 0 0
 6 16 1 0 0
 7 15 0 0 0
 8 15 1 1 0
 9 13 1 2 0
10 10 1 1 0
11  8 0 0 0
12  8 0 1 0
13  7 0 0 0
;
data kaplan;
   retain Shat 1;
   set spring85;
   Shat=Shat*(1 - nodead/norisk);
   varShat = Shat**2*(1 - Shat)/norisk;
   lci = Shat - 1.96*sqrt(varShat);
   uci = Shat + 1.96*sqrt(varShat);
   put Shat= lci= uci=;
   output;
proc print;
proc plot;
   plot Shat*time='*' lci*time='-' uci*time='-' / overlay;
data winter85;
   title 'Winter 1985 bob-white quail data from Pollock';
   input time norisk nodead nocensor noadded;
   cards;
 1 20 0 0 1
 2 21 0 0 1
 3 22 2 1 0
 4 19 5 0 0
 5 14 3 0 0
 6 11 0 0 0
 7 11 0 0 0
 8 11 2 0 0
 9  9 1 0 0
10  8 0 1 0
11  7 0 0 3
12 10 0 0 6
13 16 4 0 10
14 22 4 0 5
15 23 4 1 6
16 24 4 0 0
17 20 2 0 0
;
data kaplan;
   retain Shat 1;
   set winter85;
   Shat=Shat*(1 - nodead/norisk);
   varShat = Shat**2*(1 - Shat)/norisk;
   lci = Shat - 1.96*sqrt(varShat);
   uci = Shat + 1.96*sqrt(varShat);
   put Shat= lci= uci=;
   output;
proc print;
proc plot;
   plot Shat*time='*' lci*time='-' uci*time='-' / overlay;
data test;
   title 'Classroom example';
   input time norisk nodead nocensor noadded;
   cards;
10 6 1 0 0
15 5 1 0 0
20 4 1 0 0
25 3 1 0 0
30 2 1 0 0
;
data kaplan;
   retain Shat 1 Greensum 0;
   set test;
   Shat=Shat*(1 - nodead/norisk);
   varShat = Shat**2*(1 - Shat)/norisk;
   Greensum = Greensum + nodead/(norisk*(norisk-nodead));
   GVarShat = Shat*Shat*Greensum;
   lci = Shat - 1.96*sqrt(varShat);
   uci = Shat + 1.96*sqrt(varShat);
   put Shat= lci= uci=;
   output;
proc print;
proc plot;
   plot Shat*time='*' lci*time='-' uci*time='-' / overlay;
run;
