*----------------------------------------------------------------*
|   SAS code to calculate the value of the concentration         |
|      parameter, kappa, of the von Mises distribution from      |
|      a standard deviation.                                     |
*----------------------------------------------------------------*;
data stok;
   drop pi A;
   pi=4*atan(1);
   do s=0.25 to 5 by 0.25;
      link calcu;
      output;
      end;
   do s=6 to 10 by 1;
      link calcu;
      output;
      end;
   do s=15 to 50 by 5;
      link calcu;
      output;
      end;
*---------------------------------------------------------*
|   Subroutine to calculate kappa from s                  |
*---------------------------------------------------------*;
calcu:A=exp(-1*(s*pi/180)**2/2);
      kappa=1/(2*(1-A)+((1-A)**2*(0.48794-0.82905*A-1.3915*A*A))/A);
      return;
proc print;
proc plot; plot kappa*s='*';
run;
